diff --git a/src/cockpit/389-console/js/replication.js b/src/cockpit/389-console/js/replication.js
index efa6b3bc3..632aede8d 100644
--- a/src/cockpit/389-console/js/replication.js
+++ b/src/cockpit/389-console/js/replication.js
@@ -1,7 +1,41 @@
 var repl_suffix = "";
-var prev_repl_role_id ="";
-var prev_repl_role ="";
+var prev_repl_role ="no-repl";
+var prev_role_button;
 var prev_rid = "";
+var binddn_list_color = "";
+
+var agmt_action_html = 
+  '<div class="dropdown">' +
+     '<button class="btn btn-default dropdown-toggle ds-agmt-dropdown-button" type="button" id="dropdownMenu1" data-toggle="dropdown">' +
+      ' Choose Action...' +
+      '<span class="caret"></span>' +
+    '</button>' +
+    '<ul class="dropdown-menu ds-agmt-dropdown" role="menu" aria-labelledby="dropdownMenu1">' +
+      '<li role=""><a role="menuitem" tabindex="0" class="repl-agmt-btn agmt-edit-btn" href="#">View/Edit Agreement</a></li>' +
+      '<li role=""><a role="menuitem" tabindex="1" class="repl-agmt-btn" href="#">Initialize Consumer (online)</a></li>' +
+      '<li role=""><a role="menuitem" tabindex="-1" class="repl-agmt-btn" href="#">Initialize Consumer (ldif)</a></li>' +
+      '<li role=""><a role="menuitem" tabindex="-1" class="repl-agmt-btn" href="#">Send Updates Now</a></li>' +
+      '<li role=""><a role="menuitem" tabindex="-1" class="repl-agmt-btn" href="#">Enable/Disable Agreement</a></li>' +
+      '<li role=""><a role="menuitem" tabindex="-1" class="repl-agmt-btn agmt-del-btn" href="#">Delete Agreement</a></li>' +
+    '</ul>' +
+  '</div>';
+
+var winsync_agmt_action_html = 
+  '<div class="dropdown">' +
+     '<button class="btn btn-default dropdown-toggle ds-agmt-dropdown-button" type="button" id="dropdownMenu2" data-toggle="dropdown">' +
+      ' Choose Action...' +
+      '<span class="caret"></span>' +
+    '</button>' +
+    '<ul class="dropdown-menu ds-agmt-dropdown" role="menu" aria-labelledby="dropdownMenu2">' +
+      '<li role=""><a role="menuitem" tabindex="0" class="repl-agmt-btn agmt-edit-btn" href="#">View/Edit Agreement</a></li>' +
+      '<li role=""><a role="menuitem" tabindex="1" class="repl-agmt-btn" href="#">Send/Receives Updates Now</a></li>' +
+      '<li role=""><a role="menuitem" tabindex="-1" class="repl-agmt-btn" href="#">Full Re-synchronization</a></li>' +
+      '<li role=""><a role="menuitem" tabindex="-1" class="repl-agmt-btn agmt-del-btn" href="#">Delete Agreement</a></li>' +
+    '</ul>' +
+  '</div>';
+
+var cleanallruv_action_html =
+  '<button class="btn btn-default ds-agmt-dropdown-button" type="button" class="abort-cleanallruv">Abort Task</button>';
 
 function load_repl_jstree() {
   $('#repl-tree').jstree( {
@@ -19,11 +53,6 @@ function load_repl_jstree() {
       $("#repl-changelog").show();
       $("#repl-splash").hide();
       $("#repl-config").hide();
-
-      if ( $("#nsslapd-changelogdir").val() == "" ) {
-        // Default value
-        //$("#nsslapd-changelogdir").val("/var/lib/dirsrv/" + server_id + "/changelogdb");
-      }
     } else if (repl_suffix == "repl-root") {
       $("#repl-changelog").hide();
       $("#repl-config").hide();
@@ -51,6 +80,44 @@ function clear_agmt_wizard () {
   $(".ds-accordion-panel").css('display','none');
 };
 
+function clear_winsync_agmt_wizard() {
+  // Clear out winsync agreement form
+  $("#winsync-agmt-cn").val("");
+  $("#nsds7windowsdomain").val("");
+  $("#winsync-nsds5replicahost").val("");
+  $("#winsync-nsds5replicaport").val("");
+  $("#nsds7windowsreplicasubtree").val("");
+  $("#nsds7directoryreplicasubtree").val("");
+  $("#nsds7newwinusersyncenabled-checkbox").prop('checked', false);
+  $("#nsds7newwingroupsyncenabled-checkbox").prop('checked', false);
+  $("#winsync-nsds5replicabinddn").val("");
+  $("#winsync-nsds5replicacredentials").val("");
+  $("#winsync-nsds5replicacredentials-confirm").val("");
+  $("#winsync-nsds5replicabindmethod").prop('selectedIndex', 0);
+}
+
+function clear_cleanallruv_form () {
+  // Clear input fields and reset dropboxes
+  $('#force-clean').prop('checked', true);
+  $("#cleanallruv-rid").val("");
+};
+
+function clear_repl_mgr_form () {
+  $("#add-repl-pw").val("");
+  $("#add-repl-pw-confirm").val("");
+  $("#add-repl-mgr-dn").val("");
+  $("#add-repl-mgr-checkbox").prop('checked', false);
+  $("#add-repl-mgr-passwd").hide();
+}
+
+function check_repl_binddn_list () {
+  if( $("#nsds5replicabinddngroup").val() == "" && $("#repl-managers-list").has('option').length < 1) {
+    $("#repl-managers-list").css('border-color', 'red');
+  } else {
+    $("#repl-managers-list").css('border-color', binddn_list_color);
+  }
+}
+
 $(document).ready( function() {
   $("#repl-backend-selection").load("replication.html", function () {
     // Load the tree
@@ -60,6 +127,12 @@ $(document).ready( function() {
       console.log(data.selected);
       var suffix = data.selected;
     });
+    binddn_list_color = $("#repl-managers-list").css("border-color");
+
+    // Load existing replication config (if any), set role, etc
+
+    // Check repl managers list and if empty give it a red border
+    check_repl_binddn_list();
 
     $("#set-default").on("click", function() {
       $("#nsslapd-changelogdir").val("/var/lib/dirsrv/" + server_id + "/changelogdb");
@@ -69,49 +142,81 @@ $(document).ready( function() {
       prev_rid = $("#nsds5replicaid").val();
     });
 
-    $(".repl-role").on("change", function() {
+    $("#save-repl-cfg-btn").on('click', function () {
+       // validate values
+
+       // Do the save in DS 
+
+       // In case we updated the bind group...
+       check_repl_binddn_list();
+    });
+
+    /* 
+     * Setting/Changing the replication role 
+     */
+    $("#change-repl-role").on("click", function() {
+      var role_button = $("input[name=repl-role]:checked");
       var role = $("input[name=repl-role]:checked").val();
-      if (role == "master" || role == "multi-master") {
-         $("#nsds5replicaid").prop('required',true);
-         $("#nsds5replicaid").prop('disabled', false);
-         $("#nsds5replicaid").val(prev_rid);
+
+      if (prev_repl_role == role) {
+        // Nothing changed
+        return;
+      }
+
+      if (role == "master") {
+        if ($("#nsds5replicaid").val() == "" || $("#nsds5replicaid").val() === undefined ){
+          alert("Replica ID is required for a Master role");
+          return;
+        }
+        if ( !valid_num($("#nsds5replicaid").val()) ) {
+          alert("Replica ID must be a number");
+          return;
+        }
+
+        // TODO - check if replication is set up, if not launch a basic popup windows asking for replica ID
+
+        // TODO - if prev_role is not "disabled" after for confirmation before promoting replica
+        $("#repl-settings-header").html("Master Replication Settings");
+        $('#repl-cleanallruv').show();
+        $('#repl-agmts').show();
+        $("#nsds5replicaid").prop('disabled', true); // Can not edit rid after setup
       } else {
-          $("#nsds5replicaid").prop('required',false);
-          $("#nsds5replicaid").prop('disabled', true);
-          if (role == "hub"){
-            $("#nsds5replicaid").val("65535");
-          } else {
-            $("#nsds5replicaid").val("");    
-          }
+        $("#nsds5replicaid").prop('disabled', false);
+        $('#repl-cleanallruv').hide()
+        $("#nsds5replicaid").prop('required', false);
+
+        if (role == "hub"){
+          // TODO - if prev_role is not "disabled" after for confirmation before promoting/demoting replica
+          $("#nsds5replicaid").val("");
+          $("#repl-settings-header").html("Hub Replication Settings");
+          $('#repl-agmts').show();
+        } else if (role == "consumer") {
+          // consumer
+          // TODO - if prev_role is not "disabled" after for confirmation before demoting replica
+          $('#repl-agmts').hide();
+          $("#nsds5replicaid").val("");
+          $("#repl-settings-header").html("Consumer Replication Settings");   
+        }
       }
       if (role == "no-repl") {
         // This also means disable replication: delete agmts, everything
         if (confirm("Are you sure you want to disable replication and remove all agreements?")){
-           //delete everything
-            $("#repl-form").hide();
+          //delete everything
+          $("#repl-form").hide();
+          $("#nsds5replicaid").val("");
         } else {
-            //reset everything
-            $("#" + prev_repl_role_id).prop("checked", true);
-            if (prev_repl_role == "master" || prev_repl_role == "multi-master" ) {
-              $("#nsds5replicaid").prop('required',true);
-              $("#nsds5replicaid").prop('disabled', false);
-              $("#nsds5replicaid").val(prev_rid);
-            } else if (prev_repl_role == "hub") {
-              $("#nsds5replicaid").val("65535");
-            } else {
-              // consumer
-              $("#nsds5replicaid").val("");
-            }
+          prev_role_button.prop('checked', true);
+          return;
         }
-       } else {
-         $("#repl-form").show();
-         prev_repl_role_id = this.id;
-         prev_repl_role = role;
-       }
+      } else {
+        $("#repl-form").show();
+      }
+      prev_role_button = role_button;
+      prev_repl_role = role;
     });
 
     // Set up agreement table
-    $('#repl-agmt-table').DataTable( {
+    var repl_agmt_table = $('#repl-agmt-table').DataTable( {
       "paging": true,
       "bAutoWidth": false,
       "dom": '<"pull-left"f><"pull-right"l>tip',
@@ -120,13 +225,28 @@ $(document).ready( function() {
         "emptyTable": "No agreements configured"
       },
       "columnDefs": [ {
-        "targets": 4,
+        "targets": 5,
+        "orderable": false
+      } ]
+    });
+
+    // Set up windows sync agreement table
+    var repl_winsync_agmt_table = $('#repl-winsync-agmt-table').DataTable( {
+      "paging": true,
+      "bAutoWidth": false,
+      "dom": '<"pull-left"f><"pull-right"l>tip',
+      //"lengthMenu": [ 16, 32, 64, 128],
+      "language": {
+        "emptyTable": "No winsync agreements configured"
+      },
+      "columnDefs": [ {
+        "targets": 6,
         "orderable": false
       } ]
     });
 
     // Set up CleanAllRUV Table
-    $('#repl-clean-table').DataTable( {
+    var repl_clean_table = $('#repl-clean-table').DataTable( {
       "paging": true,
       "bAutoWidth": false,
       "dom": '<"pull-left"f><"pull-right"l>tip',
@@ -161,6 +281,112 @@ $(document).ready( function() {
       clear_agmt_wizard();
       $("#agmt-form").css('display', 'block');
     });
+    $("#agmt-save").on("click", function() {
+      // Get all the settings
+      var agmt_name = $("#agmt-cn").val();
+      var agmt_host = $("#nsds5replicahost").val();
+      var agmt_port = $("#nsds5replicaport").val();
+      var agmt_bind = $("#nsds5replicabinddn").val();
+      var agmt_bindpw = $("#nsds5replicacredentials").val();
+      var agmt_bindpw_confirm = $("#nsds5replicacredentials-confirm").val();
+      var agmt_conn = $("#nsds5replicatransportinfo").val();
+      var agmt_method = $("#nsds5replicabindmethod").val();
+      var agmt_exclude = $("#frac-list").val();  // exclude list
+      var agmt_tot_exclude = $("#frac-total-list").val();  // total init exclude list
+      var agmt_strip = $("#frac-strip-list").val();
+      var agmt_schedule = "";
+      var agmt_init = $("#init_options").val();
+
+      // Confirm passwords match
+      if (agmt_bindpw != agmt_bindpw_confirm) {
+        alert("Passwords do not match");
+        return;
+      }
+
+      if ( !$("#agmt-schedule-checkbox").is(":checked") ){
+        agmt_start = $("#agmt-start-time").val().replace(':','');
+        agmt_end = $("#agmt-end-time").val().replace(':','');
+
+        // build the days
+        var agmt_days = "";
+        if ( $("#schedule-sun").is(":checked") ){
+          agmt_days =  "0";
+        }
+        if ( $("#schedule-mon").is(":checked") ){
+          agmt_days += "1";
+        }
+        if ( $("#schedule-tue").is(":checked") ){
+          agmt_days += "2";
+        }
+        if ( $("#schedule-wed").is(":checked") ){
+          agmt_days += "3";
+        }
+        if ( $("#schedule-thu").is(":checked") ){
+          agmt_days += "4";
+        }
+        if ( $("#schedule-fri").is(":checked") ){
+          agmt_days += "5";
+        }
+        if ( $("#schedule-sat").is(":checked") ){
+          agmt_days += "6";
+        }
+        agmt_schedule = agmt_start + "-" + agmt_end + " " + agmt_days
+      }
+
+      // TODO add agmt to DS
+
+      // TODO Do agmt init (if requested)
+
+      // TODO get agmt status for table
+      var agmt_status = "";
+
+      // Update Agmt Table
+      repl_agmt_table.row.add( [
+            agmt_name,
+            agmt_host,
+            agmt_port,
+            "Enabled",
+            agmt_status,
+            agmt_action_html
+        ] ).draw( false );
+
+      // Done, close the form
+      $("#agmt-form").css('display', 'none');
+      clear_agmt_wizard();
+    });
+
+    // Delete agreement
+    $(document).on('click', '.agmt-del-btn', function(e) {
+      e.preventDefault();
+      // TODO  -delete agreement in DS
+
+      // Update HTML table
+      var data = repl_agmt_table.row( $(this).parents('tr') ).data();
+      var del_agmt_name = data[0];
+      if ( confirm("Are you sure you want to delete replication agreement: " + del_agmt_name) ) {
+        // TODO Delete schema
+          // Update html table
+        repl_agmt_table.row( $(this).parents('tr') ).remove().draw( false );
+      }
+    });
+
+    // Edit Agreement
+    $(document).on('click', '.agmt-edit-btn', function(e) {
+      e.preventDefault();
+      clear_agmt_wizard();
+
+      // Update HTML table
+      var data = repl_agmt_table.row( $(this).parents('tr') ).data();
+      var edit_agmt_name = data[0];
+
+      // TODO Get agreement from DS
+
+      // Set agreement form values
+      $("#agmt-wizard-title").html("<b>Edit Replication Agreement</b>");
+
+      // Open form
+      $("#agmt-form").css('display', 'block');
+    });
 
     // Handle disabling/enabling of agmt schedule panel
     $('#agmt-schedule-panel *').attr('disabled', true); /// Disabled by default
@@ -250,6 +476,301 @@ $(document).ready( function() {
         }
       }
     }
+    var repl_agmt_acc = document.getElementsByClassName("repl-agmt-accordion");
+    for (var i = 0; i < repl_agmt_acc.length; i++) {
+      repl_agmt_acc[i].onclick = function() {
+        this.classList.toggle("active");
+        var panel = this.nextElementSibling;
+        if (panel.style.display == "block") {
+            panel.style.display = "none";
+        } else {
+            panel.style.display = "block";
+        }
+      }
+    }
+
+    var repl_winsync_agmt_acc = document.getElementsByClassName("repl-winsync-agmt-accordion");
+    for (var i = 0; i < repl_winsync_agmt_acc.length; i++) {
+      repl_winsync_agmt_acc[i].onclick = function() {
+        this.classList.toggle("active");
+        var panel = this.nextElementSibling;
+        if (panel.style.display == "block") {
+            panel.style.display = "none";
+        } else {
+            panel.style.display = "block";
+        }
+      }
+    }
+
+
+    var repl_cleanruv_acc = document.getElementsByClassName("repl-cleanruv-accordion");
+    for (var i = 0; i < repl_cleanruv_acc.length; i++) {
+      repl_cleanruv_acc[i].onclick = function() {
+        this.classList.toggle("active");
+        var panel = this.nextElementSibling;
+        if (panel.style.display == "block") {
+            panel.style.display = "none";
+        } else {
+            panel.style.display = "block";
+        }
+      }
+    }
+
+    /*
+     * Handle the repl agmt wizard select lists
+     */
+
+    // Fractional attrs
+    $("#frac-list-add-btn").on("click", function () {
+      var add_attrs = $("#frac-attr-list").val();
+      if (add_attrs != '' && add_attrs.length > 0) {
+        for (var i = 0; i < add_attrs.length; i++) {
+          if ( $('#frac-list option[value="' + add_attrs[i] + '"]').val() === undefined) {
+            $('#frac-list').append($("<option/>") .val(add_attrs[i]) .text(add_attrs[i]));
+          }
+        }
+        $("#frac-attr-list").find('option:selected').remove();
+      }
+    });
+    $("#frac-list-remove-btn").on("click", function () {
+      var add_attrs = $("#frac-list").find('option:selected');
+      if (add_attrs && add_attrs != '' && add_attrs.length > 0) {
+        for (var i = 0; i < add_attrs.length; i++) {
+          if ( $('#frac-attr-list option[value="' + add_attrs[i].text + '"]').val() === undefined) {
+            $('#frac-attr-list').append($("<option/>").val(add_attrs[i].text).text(add_attrs[i].text));
+          }
+        }
+      }
+      $("#frac-list").find('option:selected').remove();
+      sort_list( $("#frac-attr-list") );
+    });
+
+
+    // Total Fractional attrs
+    $("#frac-total-list-add-btn").on("click", function () {
+      var add_attrs = $("#total-attr-list").val();
+      if (add_attrs != '' && add_attrs.length > 0) {
+        for (var i = 0; i < add_attrs.length; i++) {
+          if ( $('#frac-total-list option[value="' + add_attrs[i] + '"]').val() === undefined) {
+            // Not a duplicate
+            $('#frac-total-list').append($("<option/>") .val(add_attrs[i]) .text(add_attrs[i]));
+          }
+        }
+        $("#total-attr-list").find('option:selected').remove();
+      }
+    });
+    $("#frac-total-list-remove-btn").on("click", function () {
+      var add_attrs = $("#frac-total-list").find('option:selected');
+      if (add_attrs && add_attrs != '' && add_attrs.length > 0) {
+        for (var i = 0; i < add_attrs.length; i++) {
+          if ( $('#total-attr-list option[value="' + add_attrs[i].text + '"]').val() === undefined) {
+            $('#total-attr-list').append($("<option/>").val(add_attrs[i].text).text(add_attrs[i].text));
+          }
+        }
+      }
+      $("#frac-total-list").find('option:selected').remove();
+      sort_list( $("#total-attr-list") );
+    });
+
+    // Strip Fractional attrs
+    $("#frac-strip-list-add-btn").on("click", function () {
+      var add_attrs = $("#strip-attr-list").val();
+      if (add_attrs != '' && add_attrs.length > 0) {
+        for (var i = 0; i < add_attrs.length; i++) {
+          if ( $('#frac-strip-list option[value="' + add_attrs[i] + '"]').val() === undefined) {
+            // Not a duplicate
+            $('#frac-strip-list').append($("<option/>") .val(add_attrs[i]) .text(add_attrs[i]));
+          }
+        }
+        $("#strip-attr-list").find('option:selected').remove();
+      }
+    });
+    $("#frac-strip-list-remove-btn").on("click", function () {
+      var add_attrs = $("#frac-strip-list").find('option:selected');
+      if (add_attrs && add_attrs != '' && add_attrs.length > 0) {
+        for (var i = 0; i < add_attrs.length; i++) {
+          if ( $('#strip-attr-list option[value="' + add_attrs[i].text + '"]').val() === undefined) {
+            $('#strip-attr-list').append($("<option/>").val(add_attrs[i].text).text(add_attrs[i].text));
+          }
+        }
+      }
+      $("#frac-strip-list").find('option:selected').remove();
+      sort_list( $("#strip-attr-list") );
+    });
+
+    // Modals
+
+
+
+
+    // Winsync-agmt Agreement Wizard
+    $("#winsync-agmt-close").on("click", function() {
+      $("#winsync-agmt-form").css('display', 'none');
+    });
+    $("#winsync-agmt-cancel").on("click", function() {
+      $("#winsync-agmt-form").css('display', 'none');
+    });
+    $("#winsync-create-agmt").on("click", function() {
+      clear_winsync_agmt_wizard(); // TODO
+      $("#winsync-agmt-form").css('display', 'block');
+    });
+    $("#winsync-agmt-save").on("click", function() {
+
+      // Check passwords match:
+
+      var agmt_passwd = $("#winsync-nsds5replicacredentials").val();
+      var passwd_confirm = $("#winsync-nsds5replicacredentials-confirm").val();
+
+      if (agmt_passwd != passwd_confirm) {
+        alert("Passwords do not match!");
+        return;
+      }
+      // Get form values
+      var repl_root = repl_suffix;
+      var agmt_name = $("#winsync-agmt-cn").val();
+      var win_domain = $("#nsds7windowsdomain").val();
+      var agmt_host = $("#winsync-nsds5replicahost").val();
+      var agmt_port = $("#winsync-nsds5replicaport").val();
+      var win_subtree = $("#nsds7windowsreplicasubtree").val();
+      var ds_subtree = $("#nsds7directoryreplicasubtree").val();
+      var bind_dn = $("#winsync-nsds5replicabinddn").val();
+      var conn_protocol = $("#winsync-nsds5replicabindmethod").val();
+      var sync_new_users = "no";
+      var sync_new_groups = "no";
+      if ( $("#nsds7newwinusersyncenabled-checkbox").is(":checked") ){
+        sync_new_users = "yes";
+      }
+      if ( $("#nsds7newwingroupsyncenabled-checkbox").is(":checked") ){
+        sync_new_groups = "yes"
+      }
+
+      // Validate
+
+
+      // Update DS
+
+      // Get status
+      var agmt_status = "";
+
+      // Update Winsync Agmt Table
+      repl_winsync_agmt_table.row.add( [
+        agmt_name,
+        agmt_host,
+        agmt_port,
+        ds_subtree,
+        win_subtree,
+        agmt_status,
+        winsync_agmt_action_html
+      ] ).draw( false );
+
+      // Done
+      $("#winsync-agmt-form").css('display', 'none');
+      clear_winsync_agmt_wizard();
+    });
+
+    // Create CleanAllRUV Task
+    $("#create-cleanallruv-btn").on("click", function() {
+      clear_cleanallruv_form();
+      $("#cleanallruv-form").css('display', 'block');
+    });
+    $("#cleanallruv-close").on("click", function() {
+      $("#cleanallruv-form").css('display', 'none');
+    });
+    $("#cleanallruv-cancel").on("click", function() {
+      $("#cleanallruv-form").css('display', 'none');
+    });
+    $("#cleanallruv-save").on("click", function() {
+      $("#cleanallruv-form").css('display', 'none');
+      // Do the actual save in DS
+      // Update html
+
+      // Update Agmt Table
+      repl_clean_table.row.add( [
+        "Creation date WIP",
+        $("#cleanallruv-rid").val(),
+        "Task starting...",
+        cleanallruv_action_html
+      ] ).draw( false );
+    });
+
+    // Add repl manager
+    $("#add-repl-mgr-checkbox").change(function() {
+      if(this.checked) {
+        $("#add-repl-mgr-passwd").show();
+      } else {
+        $("#add-repl-mgr-passwd").hide();
+        $("#add-repl-pw").val("");
+        $("#add-repl-pw-confirm").val("");
+      }
+    });
+
+    // Remove repl manager
+    $("#delete-repl-manager").on("click", function () {
+      var repl_mgr_dn = $("#repl-managers-list").find('option:selected');
+      if (repl_mgr_dn.val() !== undefined) {
+        if ( confirm("Are you sure you want to delete replication manager: " + repl_mgr_dn.val() ) ) {
+          // TODO Update replica config entry, do not delete the real repl mgr entry
+
+          // Update HTML
+          repl_mgr_dn.remove();
+          check_repl_binddn_list();
+        }
+      }
+    });
+
+    // Add repl manager modal
+    $("#add-repl-manager").on("click", function() {
+      clear_repl_mgr_form();
+      $("#add-repl-mgr-form").css('display', 'block');
+    });
+    $("#add-repl-mgr-close").on("click", function() {
+      $("#add-repl-mgr-form").css('display', 'none');
+    });
+    $("#add-repl-mgr-cancel").on("click", function() {
+      $("#add-repl-mgr-form").css('display', 'none');
+    });
+    $("#add-repl-mgr-save").on("click", function() {
+      var repl_dn = $("#add-repl-mgr-dn").val();
+      if (repl_dn == ""){
+        alert("Replication Manager DN is required");
+        return;
+      }
+      if ( $("#add-repl-mgr-checkbox").is(":checked") ){
+        // Confirm passwords match
+        var agmt_bindpw = $("#add-repl-pw").val();
+        var agmt_bindpw_confirm = $("#add-repl-pw-confirm").val();
+        if (agmt_bindpw != agmt_bindpw_confirm) {
+          alert("Passwords do not match");
+          $("#add-repl-pw").val("");
+          $("#add-repl-pw-confirm").val("");
+          return;
+        }
+      }
+
+      console.log("Validate dn...");
+      if (!valid_dn(repl_dn)){
+        alert("Invalid DN for Replication Manager");
+        return;
+      }
+ 
+
+      // Do the actual save in DS
+
+      // Update html
+      $("#add-repl-mgr-form").css('display', 'none');
+      if (repl_dn != '') {
+        if ( $('#repl-managers-list option[value="' + repl_dn + '"]').val() === undefined) {
+          // It's not a duplicate
+          $('#repl-managers-list').append($("<option/>") .val(repl_dn).text(repl_dn));
+          check_repl_binddn_list();
+        }
+      }
+    });
+
+
+    $(document).on('click', '.abort-cleanallruv-btn', function(e) {
+       // TODO - abort the cleantask - update table (remove or update existing clean task?)
+    });
 
 
   });
